class WorkflowAddForm
Same name and namespace in other branches
- 11.x core/modules/workflows/src/Form/WorkflowAddForm.php \Drupal\workflows\Form\WorkflowAddForm
- 10 core/modules/workflows/src/Form/WorkflowAddForm.php \Drupal\workflows\Form\WorkflowAddForm
- 9 core/modules/workflows/src/Form/WorkflowAddForm.php \Drupal\workflows\Form\WorkflowAddForm
- 8.9.x core/modules/workflows/src/Form/WorkflowAddForm.php \Drupal\workflows\Form\WorkflowAddForm
Form for adding workflows.
@internal
Hierarchy
- class \Drupal\workflows\Form\WorkflowAddForm extends \Drupal\Core\Entity\EntityForm
Expanded class hierarchy of WorkflowAddForm
1 file declares its use of WorkflowAddForm
- Workflow.php in core/
modules/ workflows/ src/ Entity/ Workflow.php
File
-
core/
modules/ workflows/ src/ Form/ WorkflowAddForm.php, line 17
Namespace
Drupal\workflows\FormView source
class WorkflowAddForm extends EntityForm {
/**
* The workflow type plugin manager.
*
* @var \Drupal\Component\Plugin\PluginManagerInterface
*/
protected $workflowTypePluginManager;
/**
* WorkflowAddForm constructor.
*
* @param \Drupal\Component\Plugin\PluginManagerInterface $workflow_type_plugin_manager
* The workflow type plugin manager.
*/
public function __construct(PluginManagerInterface $workflow_type_plugin_manager) {
$this->workflowTypePluginManager = $workflow_type_plugin_manager;
}
/**
* {@inheritdoc}
*/
public static function create(ContainerInterface $container) {
return new static($container->get('plugin.manager.workflows.type'));
}
/**
* {@inheritdoc}
*/
public function form(array $form, FormStateInterface $form_state) {
$form = parent::form($form, $form_state);
/** @var \Drupal\workflows\WorkflowInterface $workflow */
$workflow = $this->entity;
$form['label'] = [
'#type' => 'textfield',
'#title' => $this->t('Label'),
'#maxlength' => 255,
'#default_value' => $workflow->label(),
'#required' => TRUE,
];
$form['id'] = [
'#type' => 'machine_name',
'#default_value' => $workflow->id(),
'#machine_name' => [
'exists' => [
Workflow::class,
'load',
],
],
];
$workflow_types = array_column($this->workflowTypePluginManager
->getDefinitions(), 'label', 'id');
$form['workflow_type'] = [
'#type' => 'select',
'#title' => $this->t('Workflow type'),
'#required' => TRUE,
'#options' => $workflow_types,
];
return $form;
}
/**
* {@inheritdoc}
*/
public function save(array $form, FormStateInterface $form_state) {
/** @var \Drupal\workflows\WorkflowInterface $workflow */
$workflow = $this->entity;
$return = $workflow->save();
if (empty($workflow->getTypePlugin()
->getStates())) {
$this->messenger()
->addStatus($this->t('Created the %label Workflow. In order for the workflow to be enabled there needs to be at least one state.', [
'%label' => $workflow->label(),
]));
$form_state->setRedirectUrl($workflow->toUrl('add-state-form'));
}
else {
$this->messenger()
->addStatus($this->t('Created the %label Workflow.', [
'%label' => $workflow->label(),
]));
$form_state->setRedirectUrl($workflow->toUrl('edit-form'));
}
return $return;
}
/**
* {@inheritdoc}
*/
protected function copyFormValuesToEntity(EntityInterface $entity, array $form, FormStateInterface $form_state) {
// This form can only set the workflow's ID, label and the weights for each
// state.
/** @var \Drupal\workflows\WorkflowInterface $entity */
$values = $form_state->getValues();
$entity->set('label', $values['label']);
$entity->set('id', $values['id']);
$entity->set('type', $values['workflow_type']);
}
}
Members
| Title Sort descending | Modifiers | Object type | Summary | Overriden Title | Overrides |
|---|---|---|---|---|---|
| AutowiredInstanceTrait::createInstanceAutowired | public static | function | Instantiates a new instance of the implementing class using autowiring. | ||
| AutowiredInstanceTrait::getAutowireArguments | private static | function | Resolves arguments for a method using autowiring. | ||
| DependencySerializationTrait::$_entityStorages | protected | property | An array of entity type IDs keyed by the property name of their storages. | ||
| DependencySerializationTrait::$_serviceIds | protected | property | An array of service IDs keyed by property name used for serialization. | ||
| DependencySerializationTrait::__sleep | public | function | 2 | ||
| DependencySerializationTrait::__wakeup | public | function | 2 | ||
| EntityForm::$entity | protected | property | The entity being used by this form. | 10 | |
| EntityForm::$entityTypeManager | protected | property | The entity type manager. | 3 | |
| EntityForm::$moduleHandler | protected | property | The module handler service. | 3 | |
| EntityForm::$operation | protected | property | The name of the current operation. | ||
| EntityForm::actions | protected | function | Returns an array of supported actions for the current entity form. | 34 | |
| EntityForm::actionsElement | protected | function | Returns the action form element for the current entity form. | ||
| EntityForm::afterBuild | public | function | Form element #after_build callback: Updates the entity with submitted data. | 1 | |
| EntityForm::buildEntity | public | function | Overrides EntityFormInterface::buildEntity | 5 | |
| EntityForm::buildForm | public | function | Overrides FormInterface::buildForm | 13 | |
| EntityForm::getBaseFormId | public | function | Overrides BaseFormIdInterface::getBaseFormId | 3 | |
| EntityForm::getCallableFromDefinition | protected | function | Gets a callable from a string or array definition if possible. | ||
| EntityForm::getEntity | public | function | Overrides EntityFormInterface::getEntity | ||
| EntityForm::getEntityFromRouteMatch | public | function | Overrides EntityFormInterface::getEntityFromRouteMatch | 3 | |
| EntityForm::getFormId | public | function | Overrides FormInterface::getFormId | 14 | |
| EntityForm::getOperation | public | function | Overrides EntityFormInterface::getOperation | ||
| EntityForm::init | protected | function | Initialize the form state and the entity before the first form build. | 3 | |
| EntityForm::prepareEntity | protected | function | Prepares the entity object before the form is built first. | 3 | |
| EntityForm::prepareInvokeAll | protected | function | Invokes the specified prepare hook variant. | ||
| EntityForm::processForm | public | function | Process callback: assigns weights and hides extra fields. | ||
| EntityForm::setEntity | public | function | Overrides EntityFormInterface::setEntity | ||
| EntityForm::setEntityTypeManager | public | function | Overrides EntityFormInterface::setEntityTypeManager | ||
| EntityForm::setModuleHandler | public | function | Overrides EntityFormInterface::setModuleHandler | ||
| EntityForm::setOperation | public | function | Overrides EntityFormInterface::setOperation | ||
| EntityForm::submitForm | public | function | This is the default entity object builder function. It is called before any other submit handler to build the new entity object to be used by the following submit handlers. At this point of the form workflow the entity is validated and the form state… |
Overrides FormInterface::submitForm | 21 |
| FormBase::$configFactory | protected | property | The config factory. | 1 | |
| FormBase::$requestStack | protected | property | The request stack. | 1 | |
| FormBase::$routeMatch | protected | property | The route match. | ||
| FormBase::config | protected | function | Retrieves a configuration object. | ||
| FormBase::configFactory | protected | function | Gets the config factory for this form. | 1 | |
| FormBase::container | private | function | Returns the service container. | ||
| FormBase::currentUser | protected | function | Gets the current user. | 2 | |
| FormBase::getRequest | protected | function | Gets the request object. | Overrides HtmxRequestInfoTrait::getRequest | |
| FormBase::getRouteMatch | protected | function | Gets the route match. | ||
| FormBase::logger | protected | function | Gets the logger for a specific channel. | ||
| FormBase::redirect | protected | function | Returns a redirect response object for the specified route. | ||
| FormBase::resetConfigFactory | public | function | Resets the configuration factory. | ||
| FormBase::setConfigFactory | public | function | Sets the config factory for this form. | ||
| FormBase::setRequestStack | public | function | Sets the request stack object to use. | ||
| FormBase::validateForm | public | function | Overrides FormInterface::validateForm | 54 | |
| HtmxRequestInfoTrait::getHtmxCurrentUrl | protected | function | Retrieves the URL of the requesting page from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxPrompt | protected | function | Retrieves the prompt from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTarget | protected | function | Retrieves the target identifier from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTrigger | protected | function | Retrieves the trigger identifier from an HTMX request header. | ||
| HtmxRequestInfoTrait::getHtmxTriggerName | protected | function | Retrieves the trigger name from an HTMX request header. | ||
| HtmxRequestInfoTrait::isHtmxBoosted | protected | function | Determines if the request is boosted by HTMX. | ||
| HtmxRequestInfoTrait::isHtmxHistoryRestoration | protected | function | Determines if if the request is for history restoration. | ||
| HtmxRequestInfoTrait::isHtmxRequest | protected | function | Determines if the request is sent by HTMX. | ||
| LoggerChannelTrait::$loggerFactory | protected | property | The logger channel factory service. | ||
| LoggerChannelTrait::getLogger | protected | function | Gets the logger for a specific channel. | ||
| LoggerChannelTrait::setLoggerFactory | public | function | Injects the logger channel factory. | ||
| MessengerTrait::$messenger | protected | property | The messenger. | 27 | |
| MessengerTrait::messenger | public | function | Gets the messenger. | 27 | |
| MessengerTrait::setMessenger | public | function | Sets the messenger. | ||
| RedirectDestinationTrait::$redirectDestination | protected | property | The redirect destination service. | 2 | |
| RedirectDestinationTrait::getDestinationArray | protected | function | Prepares a 'destination' URL query parameter for use with \Drupal\Core\Url. | ||
| RedirectDestinationTrait::getRedirectDestination | protected | function | Returns the redirect destination service. | ||
| RedirectDestinationTrait::setRedirectDestination | public | function | Sets the redirect destination service. | ||
| StringTranslationTrait::$stringTranslation | protected | property | The string translation service. | 3 | |
| StringTranslationTrait::formatPlural | protected | function | Formats a string containing a count of items. | ||
| StringTranslationTrait::getNumberOfPlurals | protected | function | Returns the number of plurals supported by a given language. | ||
| StringTranslationTrait::getStringTranslation | protected | function | Gets the string translation service. | ||
| StringTranslationTrait::setStringTranslation | public | function | Sets the string translation service to use. | 2 | |
| StringTranslationTrait::t | protected | function | Translates a string to the current language or to a given language. | 1 | |
| WorkflowAddForm::$workflowTypePluginManager | protected | property | The workflow type plugin manager. | ||
| WorkflowAddForm::copyFormValuesToEntity | protected | function | Overrides EntityForm::copyFormValuesToEntity | ||
| WorkflowAddForm::create | public static | function | Overrides AutowireTrait::create | ||
| WorkflowAddForm::form | public | function | Overrides EntityForm::form | ||
| WorkflowAddForm::save | public | function | Overrides EntityForm::save | ||
| WorkflowAddForm::__construct | public | function | WorkflowAddForm constructor. |
Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.